/*
gcc -o windows_file_recv windows_file_recv.c -lwsock32 -Wall -DTEST_PRINTF
*/

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <WinSock2.h>

#include "dirent.h"

#define PACKSZ 4096

using System.Net.Sockets;

void ErrorHandling(char* message);
void sendToLog(char* tmp, int rlen);
char* getCurrentTime(void);
int get_filesz_recv(SOCKET sock);
char* get_filename_recv(SOCKET sock);
char* replace_str_filename(const char* s, const char* oldword, const char* newword);
char* get_replace_filename(char* filename);
char* get_duplicate_filename(char* filename);
int receiver_data(SOCKET sock);

/*---------------------------------------------------------------------------------
 *function name : main
 *--------------------------------------------------------------------------------*/
int main(int argc, char* argv[])
{
    int rc;

    WSADATA wsaData;
    SOCKET ssock, csock;
    SOCKADDR_IN servAddr, clntAddr;

    int szClntAddr;

    if (argc != 2)
    {
        printf("Usage:%s <port>\n", argv[0]);
        return (-1);
    }

    if (WSAStartup(MAKEWORD(2, 2), &wsaData) != 0) ErrorHandling("WSAStartup() error!");

    ssock = socket(PF_INET, SOCK_STREAM, 0);
    if (ssock == INVALID_SOCKET) ErrorHandling("socket() error");

    memset(&servAddr, 0, sizeof(servAddr));
    servAddr.sin_family = AF_INET;
    servAddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servAddr.sin_port = htons(atoi(argv[1]));

    if (bind(ssock, (SOCKADDR*)&servAddr, sizeof(servAddr)) == SOCKET_ERROR) ErrorHandling("bind() error");
    if (listen(ssock, 5) == SOCKET_ERROR) ErrorHandling("listen() error");

    while (1)
    {
        szClntAddr = sizeof(clntAddr);
        csock = accept(ssock, (SOCKADDR*)&clntAddr, &szClntAddr);
        if (csock == INVALID_SOCKET) ErrorHandling("accept() error");

        rc = receiver_data(csock);

        closesocket(csock);
    }
    closesocket(ssock);
    WSACleanup(); //α׷   ʱȭ  ̺귯 
    return 0;
}

void ErrorHandling(char* message)
{
    fputs(message, stderr);
    fputc('\n', stderr);
    exit(1);
}

void sendToLog(char* tmp, int rlen)
{
    fprintf(stderr, "[%.4d][%.*s]\n", rlen, rlen, tmp);
}

/*---------------------------------------------------------------------------------
 *function name : getCurrentTime
 *--------------------------------------------------------------------------------*/
char* getCurrentTime(void)
{
    static char tmp[1024];

    time_t t = time(NULL);
    struct tm tm = *localtime(&t);

memset(tmp, 0x00, sizeof(tmp));
sprintf(tmp, "%d-%d-%d %d:%d:%d",
     tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday,
     tm.tm_hour, tm.tm_min, tm.tm_sec);

return (tmp);
}
/*---------------------------------------------------------------------------------
 *function name : get_filesz_recv
 *--------------------------------------------------------------------------------*/
int get_filesz_recv(SOCKET sock)
{
    char tmp[PACKSZ];

#if (1)
char data_[PACKSZ];
int datalen_;
#endif

    char filesize[1024];
    int ii, ff, recv_len, filesz;

    datalen_ = 0;
    while (1)
    {
        recv_len = recv(sock, tmp, PACKSZ, 0);
        printf("(debugging)(filesize)recv_len[%d]\n", recv_len);
        ff = 0;
        if (recv_len > 0)
        {
            for (ii = 0; ii < recv_len; ii++)
            {
                data_[datalen_] = tmp[ii];
                datalen_ = datalen_ + 1;
                if (datalen_ > 2 && data_[datalen_ - 1] == 0x0a && data_[datalen_ - 2] == 0x0d && (unsigned char)(data_[datalen_ - 3]) == 0xff)
				{
#if (1)
                    ff=100;
					break;
#endif
    datalen_ = 0;
    //memset(data_, 0x00, sizeof(data_));
}
			}
			if (ff == 100) break;
		}

        else break;
	}

	if (ff != 100) return (-5);

memset(filesize, 0x00, sizeof(filesize));
memcpy(filesize, data_, datalen_ - 3);
filesz = atoi(filesize);
printf("(information)(filesize)file size is :[%d]\n", filesz);

return (filesz);
}
/*---------------------------------------------------------------------------------
 *function name : getlastfilename
 *--------------------------------------------------------------------------------*/
char* getlastfilename(char* path)
{
    static char filename[256] = "";
    char* ptr = NULL;

    ptr = strrchr(path, '\\');     //ڿ(path) ڿ '\' ġ ˻Ͽ ȯ     
    if (ptr == NULL)
    {
        strcpy(filename, path);
    }
    else
    {
        strcpy(filename, ptr + 1); // Ϳ +1 Ͽ 
    }
    return filename;
}
/*---------------------------------------------------------------------------------
 *function name : get_filename_recv
 *--------------------------------------------------------------------------------*/
char* get_filename_recv(SOCKET sock)
{
    static char real_filename[1024];
    char tmp[PACKSZ];

#if (1)
char data_[PACKSZ];
int datalen_;
#endif

    char filename[1024];
    int ii, kk, ff, recv_len;

    memset(filename, 0x00, sizeof(filename));
    memset(real_filename, 0x00, sizeof(real_filename));

    datalen_ = 0;
    while (1)
    {
        recv_len = recv(sock, tmp, PACKSZ, 0);
        printf("(debugging)(filename)recv_len[%d]\n", recv_len);

        ff = 0;
        if (recv_len > 0)
        {
            for (ii = 0; ii < recv_len; ii++)
            {
                data_[datalen_] = tmp[ii];
                datalen_ = datalen_ + 1;
                if (datalen_ > 2 && data_[datalen_ - 1] == 0x0a && data_[datalen_ - 2] == 0x0d && (unsigned char)(data_[datalen_ - 3]) == 0xff)
				{
    ff = 100;
    break;
}
			}
			if (ff == 100) break;
		}

        else
{
    break;
}
	}
	printf("(information)(filename)include fullpath, filename :[%.*s]\n", datalen_, data_);

if (ff != 100) return (NULL);

memset(filename, 0x00, sizeof(filename));
memcpy(filename, data_, datalen_ - 3);

printf("(information)(filename)include fullpath, filename :[%s]\n", filename);

memset(real_filename, 0x00, sizeof(real_filename));
strcpy(real_filename, getlastfilename(filename));

printf("(information)(filename)filename :[%s]\n", real_filename);
printf("(information)(filename)except directory, filename :[%s]\n", real_filename);

return (real_filename);
}
/*---------------------------------------------------------------------------------
 *function name : replace_str_filename
 *--------------------------------------------------------------------------------*/
char* replace_str_filename(const char* s, const char* oldword, const char* newword)
{
    static char* result;
    int i, cnt = 0;
    int newwordlen = strlen(newword);
    int oldwordlen = strlen(oldword);

    for (i = 0; s[i] != '\0'; i++)
    {
        if (strstr(&s[i], oldword) == &s[i])
        {
            cnt++;
            // Jumping to index after the old word. 
            i += oldwordlen - 1;
        }
    }
    result = (char*)malloc(i + cnt * (newwordlen - oldwordlen) + 1);

    i = 0;
    while (*s)
    {
        // compare the substring with the result 
        if (strstr(s, oldword) == s)
        {
            strcpy(&result[i], newword);
            i += newwordlen;
            s += oldwordlen;
        }
        else
        {
            result[i++] = *s++;
        }
    }

    result[i] = '\0';
    return result;
}
/*---------------------------------------------------------------------------------
 *function name : get_replace_filename
 *--------------------------------------------------------------------------------*/
char* get_replace_filename(char* filename)
{
    int ii, kk;
    char oldword[1024];
    char newword[1024];

    static char changename[1024];
    memset(changename, 0x00, sizeof(changename));

    ii = 0;
    for (kk = 0; kk < 100; kk++)
    {
        memset(oldword, 0x00, sizeof(oldword));
        sprintf(oldword, "_%.4d", kk);

        if (strstr(filename, oldword) != NULL)
        {
            printf("(debugging)(get_replace_filename)filename check succ[%s]/[%s]\n", filename, oldword);

            memset(newword, 0x00, sizeof(newword));
            sprintf(newword, "_%.4d", kk + 1);

            strcpy(changename, replace_str_filename(filename, oldword, newword));
            printf("(debugging)(get_replace_filename)changename check[%s]\n", changename);

            ii = 100;
            break;
        }
    }
    if (ii == 100) return (changename);

    memset(oldword, 0x00, sizeof(oldword));
    sprintf(oldword, "_%.4d", 0);
    printf("(debugging)(get_replace_filename)filename check fail[%s]/[%s]\n", filename, oldword);

    sprintf(changename, "%s_%.4d", filename, 0);
    return (changename);
}
/*---------------------------------------------------------------------------------
 *function name : get_duplicate_filename
 *--------------------------------------------------------------------------------*/
char* get_duplicate_filename(char* filename)
{
    int kk;
    static char changename[1024];

    memset(changename, 0x00, sizeof(changename));

#if (0)
//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX
//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX
//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX
//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX//LINUX

    if((dp = opendir(".")) == NULL){
      fprintf(stderr,"directory open error\n");
      exit(-1);
  	}

	kk=0;
    while((dir = readdir(dp)) != NULL)
	{
        if(dir->d_ino == 0) continue;

	    printf("[%s],", dir->d_name);
	    printf("[%d],", dir->d_reclen);
	    printf("[%d],", dir->d_ino);
	    printf("\n");
	    printf("(debugging)(get_duplicate_filename)filename check fail[%s]/[%s]\n", dir->d_name, filename);

	    if(strcmp(dir->d_name, filename) == 0)
		{
			printf("(debugging)(get_duplicate_filename)filename check succ[%s]/[%s]\n", dir->d_name, filename);
			strcpy(changename, get_replace_filename(filename));
			kk=100;
			break;
		}
    }
    closedir(dp);
#endif


#if (1)
//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS
//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS
//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS
//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS//WINDOWS
	kk = 0;
	DIR *dir;
	struct dirent *ent;

	/* open directory stream */
	dir = opendir (".");
	if (dir != NULL) 
	{
		/* print all the files and directories within directory */
		while ((ent = readdir (dir)) != NULL) 
		{
			//printf("(debugging)(get_duplicate_filename)filename check fail[%s]/[%s]\n", ent->d_name, filename);

			if(strcmp(ent->d_name, filename) == 0)
			{
				printf("(debugging)(get_duplicate_filename)filename check succ[%s]/[%s]\n", ent->d_name, filename);
				strcpy(changename, get_replace_filename(filename));
				printf("(debugging)(get_duplicate_filename)filename check succ[%s]/[%s]\n", ent->d_name, changename);

				kk=100;
				break;
			}
		}
		closedir (dir);
	}
#endif

    if (kk == 100) return (changename);
    return (filename);
}
/*---------------------------------------------------------------------------------
 *function name : receiver_data
 *--------------------------------------------------------------------------------*/
int receiver_data(SOCKET sock)
{
    FILE* stream = NULL;
    char filename[1024], tmp[1024], duptmp[1024];

    int bufsz = PACKSZ;
    char* buf_ = (char*)malloc(sizeof(char) * bufsz);

    int sz, filesz, cur;

    filesz = get_filesz_recv(sock);
    if (filesz < 0) return (-5);

    strcpy(tmp, get_filename_recv(sock));
    if (tmp == NULL) return (-4);

    printf("(debugging)(receiver_data)filename check 1:[%s]\n", tmp);
    strcpy(filename, get_duplicate_filename(tmp));
    printf("(debugging)(receiver_data)filename check 2:[%s]\n", filename);
    while (1)
    {
        memset(tmp, 0x00, sizeof(tmp));
        strcpy(tmp, filename);

        strcpy(duptmp, get_duplicate_filename(tmp));
        if (strcmp(duptmp, filename) != 0)
        {
            printf("(debugging)(receiver_data)loop check succ[%s]\n", get_duplicate_filename(tmp));
            strcpy(filename, duptmp);
        }
        else break;
    }
    printf("(debugging)(receiver_data)filename check 3:[%s]\n", filename);

    if ((stream = fopen(filename, "wb")) == NULL) return (-1);

    cur = 0;
    while (1)
    {
        sz = recv(sock, buf_, PACKSZ, 0);

        if (sz == -1)
        {
            break;
        }
        else if (sz != bufsz)
        {
            if (sz + cur < filesz)
            {
                send(sock, "no", strlen("no"), 0);
                continue;
            }
        }

        send(sock, "go", strlen("go"), 0);
        fwrite(buf_, 1, sz, stream);

        cur += sz;

        if (cur > filesz)
        {
            break;
        }
        else if (filesz == cur)
        {
            printf("(information)recv complete ---> ");
            printf("[%s]\n", filename);
            break;
        }
    }
    free(buf_);
    if (stream != NULL) fclose(stream);

    return (0);
}


